           (*-------------------------------------------*
            |            October 2007 for Isabelle 2005 |
            |           November 2008 for Isabelle 2008 |
            |                                           |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory CSP_F_law_dist_v4_1
imports CSP_F_law_dist Trace_v4_1  CSP_F_law_alpha_par
begin

(*****************************************************************

         1. 

 *****************************************************************)

(* --------------------------------------------------- *
     distribution hiding over sequential composition
 * --------------------------------------------------- *)

(*------------------*
 |      csp law     |
 *------------------*)

lemma cspT_Seq_compo_hide_dist: 
  "(P ;; Q) -- X =T[M,M] (P -- X) ;; (Q -- X)"
apply (simp add: cspT_semantics)
apply (rule order_antisym)

(* => *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim conjE exE disjE)
 apply (simp_all)

  (* 1 *)
 apply (rule disjI1)
 apply (rule_tac x="sa --tr X" in exI)
 apply (simp add: rmTick_hide)
 apply (rule_tac x="sa" in exI)
 apply (simp)

  (* 2 *)
 apply (rule disjI2)
 apply (rule_tac x="sa --tr X" in exI)
 apply (rule_tac x="ta --tr X" in exI)
 apply (simp)
 apply (rule conjI)
  apply (rule_tac x="sa ^^ <Tick>" in exI)
  apply (simp)
  apply (rule_tac x="ta" in exI)
  apply (simp)

(* <= *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim disjE conjE exE)
  (* 1 *)
  apply (insert trace_last_noTick_or_Tick)
  apply (drule_tac x="sa" in spec)
  apply (elim disjE conjE exE)
   apply (simp)
   apply (rule_tac x="sa" in exI)
   apply (simp)
   apply (rule disjI1)
   apply (rule_tac x="sa" in exI)
   apply (simp)

   apply (simp)
   apply (rule_tac x="sb" in exI)
   apply (simp)
   apply (rule disjI1)
   apply (rule_tac x="sb ^^ <Tick>" in exI)
   apply (simp)

 (* 2 *)
  apply (drule_tac x="sa" in spec)
  apply (elim disjE conjE exE)
   apply (simp)
   apply (subgoal_tac "noTick(sa --tr X)")
   apply (rotate_tac 2)
   apply (drule sym)
   apply (simp del: hide_tr_noTick)
   apply (simp)

   apply (simp)
   apply (rule_tac x="sc ^^ sb" in exI)
   apply (simp)
   apply (rule disjI2)
   apply (rule_tac x="sc" in exI)
   apply (rule_tac x="sb" in exI)
   apply (simp)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma cspF_Seq_compo_hide_dist: 
  "(P ;; Q) -- X =F[M,M] (P -- X) ;; (Q -- X)"
apply (simp add: cspF_cspT_semantics)
apply (simp add: cspT_Seq_compo_hide_dist)
apply (rule order_antisym)

(* => *)
 apply (rule)
 apply (simp add: in_failures)
 apply (elim conjE exE disjE)
 apply (simp_all)

  (* 1 *)
 apply (rule disjI1)
 apply (rule_tac x="sa" in exI)
 apply (simp)

  (* 2 *)
 apply (rule disjI2)
 apply (rule_tac x="sb --tr X" in exI)
 apply (rule_tac x="t --tr X" in exI)
 apply (simp)
 apply (rule conjI)
  apply (simp add: in_traces)
  apply (rule_tac x="sb ^^ <Tick>" in exI)
  apply (simp)
  apply (rule_tac x="t" in exI)
  apply (simp)

(* <= *)
 apply (rule)
 apply (simp add: in_failures)
 apply (elim disjE conjE exE)
  (* 1 *)
  apply (rule_tac x="sa" in exI)
  apply (simp)
  (* 2 *)
  apply (simp add: in_traces)
  apply (elim conjE exE)
  apply (insert trace_last_noTick_or_Tick)
  apply (drule_tac x="sc" in spec)
  apply (elim disjE conjE exE)

   apply (subgoal_tac "noTick(sc --tr X)")
   apply (rotate_tac 4)
   apply (drule sym)
   apply (simp del: hide_tr_noTick)
   apply (simp)

   apply (simp)
   apply (rule_tac x="sd ^^ sb" in exI)
   apply (simp)
   apply (rule disjI2)
   apply (rule_tac x="sd" in exI)
   apply (rule_tac x="sb" in exI)
   apply (simp)
done

(* --------------------------------------------------- *
         distribution hiding over interleaving
 * --------------------------------------------------- *)

(*------------------*
 |      csp law     |
 *------------------*)

lemma cspT_Interleave_hide_dist: 
  "(P ||| Q) -- X =T[M,M] (P -- X) ||| (Q -- X)"
apply (simp add: cspT_semantics)
apply (rule order_antisym)

(* => *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim conjE exE disjE)
 apply (simp_all)
 apply (rule_tac x="sa --tr X" in exI)
 apply (rule_tac x="ta --tr X" in exI)
 apply (simp add: interleave_of_hide_tr_ex)
 apply (force)

(* <= *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim disjE conjE exE)

 apply (simp add: interleave_of_hide_tr_ex)
 apply (elim conjE exE)
 apply (simp)
 apply (rule_tac x="v" in exI)
 apply (simp)
 apply (force)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma cspF_Interleave_hide_dist: 
  "(P ||| Q) -- X =F[M,M] (P -- X) ||| (Q -- X)"
apply (simp add: cspF_cspT_semantics)
apply (simp add: cspT_Interleave_hide_dist)
apply (rule order_antisym)

(* => *)
 apply (rule)
 apply (simp add: in_failures)
 apply (elim conjE exE)
 apply (simp)

 apply (rule_tac x="(Ev ` X Un Y) Int Xa" in exI)
 apply (rule_tac x="(Ev ` X Un Z) Int Xa" in exI)
 apply (intro conjI)

 (* 1 *)
  apply (force)

 (* 2 *)
  apply (force)

 (* 3 *)
  apply (rule_tac x="sb --tr X" in exI)
  apply (rule_tac x="t --tr X" in exI)
  apply (simp add: interleave_of_hide_tr_ex)
  apply (intro conjI)

   apply (force)

   apply (rule_tac x="sb" in exI)
   apply (simp)
   apply (subgoal_tac "Ev ` X Un (Ev ` X Un Y) Int Xa <= Y")
   apply (rule memF_F2)
   apply (simp)
   apply (simp)
   apply (force)

   apply (rule_tac x="t" in exI)
   apply (simp)
   apply (subgoal_tac "Ev ` X Un (Ev ` X Un Z) Int Xa <= Z")
   apply (rule memF_F2)
   apply (simp)
   apply (simp)
   apply (force)

(* <= *)
 apply (rule)
 apply (simp add: in_failures)
 apply (elim conjE exE)
 apply (simp add: interleave_of_hide_tr_ex)
 apply (elim conjE exE)
 apply (simp)
 apply (rule_tac x="v" in exI)
 apply (simp)
 apply (rule_tac x="Ev ` X Un Y" in exI)
 apply (rule_tac x="Ev ` X Un Z" in exI)
 apply (intro conjI)
  apply (force)
  apply (force)
  apply (force)
done

(* --------------------------------------------------- *
    distribution renaming over sequential composition
 * --------------------------------------------------- *)

(*------------------*
 |      csp law     |
 *------------------*)

lemma cspT_Seq_compo_renaming_dist: 
  "(P ;; Q) [[r]] =T[M,M] (P [[r]]) ;; (Q [[r]])"
apply (simp add: cspT_semantics)
apply (rule order_antisym)

(* => *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim conjE exE disjE)
 apply (simp_all)

  (* 1 *)
  apply (rule disjI1)
  apply (rule_tac x="t" in exI)
  apply (subgoal_tac "noTick t")
  apply (simp)
  apply (rule_tac x="rmTick sa" in exI)
  apply (simp)
  apply (rule memT_prefix_closed)
  apply (simp)
  apply (simp)
  apply (rule ren_tr_noTick_left)
  apply (simp)
  apply (simp)

  (* 2 *)
  apply (rule disjI2)
  apply (simp add: ren_tr_appt_decompo_left)
  apply (elim conjE exE)

  apply (simp)
  apply (rule_tac x="t1" in exI)
  apply (rule_tac x="t2" in exI)
  apply (simp)
  apply (rule conjI)

   apply (rule_tac x="sa ^^ <Tick>" in exI)
   apply (simp add: ren_tr_noTick_left)

   apply (simp add: ren_tr_noTick_left)
   apply (rule_tac x="ta" in exI)
   apply (simp)

(* <= *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim disjE conjE exE)
  (* 1 *)
  apply (insert trace_last_noTick_or_Tick)
  apply (drule_tac x="s" in spec)
  apply (elim disjE conjE exE)
   apply (simp)
   apply (rule_tac x="sa" in exI)
   apply (simp)
   apply (rule disjI1)
   apply (rule_tac x="sa" in exI)
   apply (simp)
   apply (simp add: ren_tr_noTick_right)

   apply (simp)
   apply (simp add: ren_tr_appt_decompo_right)
   apply (elim conjE exE)
   apply (simp)
   apply (rule_tac x="s1" in exI)
   apply (simp)
   apply (rule disjI1)
   apply (rule_tac x="s1 ^^ <Tick>" in exI)
   apply (simp)

 (* 2 *)
  apply (simp)
  apply (simp add: ren_tr_appt_decompo_right)
  apply (elim conjE exE)
  apply (simp)
  apply (rule_tac x="s1 ^^ sb" in exI)
  apply (rule conjI)

   apply (force)
   apply (force)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma cspF_Seq_compo_renaming_dist: 
  "(P ;; Q) [[r]] =F[M,M] (P [[r]]) ;; (Q [[r]])"
apply (simp add: cspF_cspT_semantics)
apply (simp add: cspT_Seq_compo_renaming_dist)
apply (rule order_antisym)

(* => *)
 apply (rule)
 apply (simp add: in_failures)
 apply (elim conjE exE disjE)
 apply (simp_all)

  (* 1 *)
 apply (rule disjI1)
 apply (simp add: ren_tr_noTick_left)
 apply (rule_tac x="sa" in exI)
 apply (simp add: ren_inv_insert_Tick)

  (* 2 *)
 apply (rule disjI2)
 apply (simp add: ren_tr_appt_decompo_left)
 apply (elim conjE exE)
 apply (simp)
 apply (rule_tac x="t1" in exI)
 apply (rule_tac x="t2" in exI)
 apply (simp)
 apply (rule conjI)
  apply (simp add: in_traces)
  apply (rule_tac x="sb ^^ <Tick>" in exI)
  apply (simp add: ren_tr_noTick_left)

  apply (simp add: ren_tr_noTick_left)
  apply (rule_tac x="t" in exI)
  apply (simp)

(* <= *)
 apply (rule)
 apply (simp add: in_failures)
 apply (elim disjE conjE exE)
  (* 1 *)
  apply (rule_tac x="sa" in exI)
  apply (simp add: ren_inv_insert_Tick)
  apply (simp add: ren_tr_noTick_right)

  (* 2 *)
  apply (simp add: in_traces)
  apply (elim conjE exE)
  apply (simp add: ren_tr_appt_decompo_right)
  apply (elim conjE exE)
  apply (simp)
  apply (rule_tac x="s1 ^^ sb" in exI)
  apply (simp)

  apply (rule conjI)
   apply (rule_tac x="s1" in exI)
   apply (rule_tac x="sb" in exI)
   apply (simp)

   apply (rule disjI2)
   apply (rule_tac x="s1" in exI)
   apply (rule_tac x="sb" in exI)
   apply (simp)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma cspT_Interleave_renaming_dist: 
  "(P ||| Q) [[r]] =T[M,M] (P [[r]]) ||| (Q [[r]])"
apply (simp add: cspT_semantics)
apply (rule order_antisym)

(* => *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim conjE exE disjE)
 apply (insert interleave_of_ren_tr_only_if_all)
 apply (drule_tac x="s" in spec)
 apply (drule_tac x="r" in spec)
 apply (drule_tac x="t" in spec)
 apply (drule_tac x="sa" in spec)
 apply (drule_tac x="ta" in spec)
 apply (force)

(* <= *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim conjE exE disjE)
 apply (erule rem_asmE)
 apply (insert interleave_of_ren_tr_if_all)
 apply (drule_tac x="t" in spec)
 apply (drule_tac x="r" in spec)
 apply (drule_tac x="sa" in spec)
 apply (drule_tac x="sb" in spec)
 apply (drule_tac x="s" in spec)
 apply (drule_tac x="ta" in spec)
 apply (force)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma cspF_Interleave_renaming_dist: 
  "(P ||| Q) [[r]] =F[M,M] (P [[r]]) ||| (Q [[r]])"
apply (simp add: cspF_cspT_semantics)
apply (simp add: cspT_Interleave_renaming_dist)
apply (rule order_antisym)

(* => *)
 apply (rule)
 apply (simp add: in_failures)
 apply (elim conjE exE disjE)
  apply (case_tac "Tick ~: Y & Tick ~: Z")

  apply (rule_tac x="X" in exI)
  apply (rule_tac x="X" in exI)
  apply (simp)
  apply (insert interleave_of_ren_tr_only_if_all)
  apply (drule_tac x="sa" in spec)
  apply (drule_tac x="r" in spec)
  apply (drule_tac x="s" in spec)
  apply (drule_tac x="sb" in spec)
  apply (drule_tac x="t" in spec)
  apply (simp)
  apply (elim conjE exE)
  apply (rule_tac x="s'" in exI)
  apply (rule_tac x="t'" in exI)
  apply (force)

  apply (subgoal_tac "Tick : X")

  apply (rule_tac x="(X-{Tick}) Un (Y Int {Tick})" in exI)
  apply (rule_tac x="(X-{Tick}) Un (Z Int {Tick})" in exI)
  apply (intro conjI)

   apply (force)
   apply (force)

   apply (drule_tac x="sa" in spec)
   apply (drule_tac x="r" in spec)
   apply (drule_tac x="s" in spec)
   apply (drule_tac x="sb" in spec)
   apply (drule_tac x="t" in spec)
   apply (simp)
   apply (elim conjE exE)
   apply (rule_tac x="s'" in exI)
   apply (rule_tac x="t'" in exI)
   apply (simp)
   apply (intro conjI)

    apply (rule_tac x="sb" in exI)
    apply (simp)
    apply (rule memF_F2)
    apply (simp)
    apply (force)

    apply (rule_tac x="t" in exI)
    apply (simp)
    apply (rule memF_F2)
    apply (simp)
    apply (force)

  apply (simp add: ren_inv_def)
  apply (force)

(* <= *)
 apply (rule)
 apply (simp add: in_failures)
 apply (elim disjE conjE exE)
 apply (erule rem_asmE)
 apply (insert interleave_of_ren_tr_if_all)
  apply (drule_tac x="s" in spec)
  apply (drule_tac x="r" in spec)
  apply (drule_tac x="sb" in spec)
  apply (drule_tac x="sc" in spec)
  apply (drule_tac x="sa" in spec)
  apply (drule_tac x="t" in spec)
  apply (simp)
  apply (elim conjE exE)

   apply (rule_tac x="u" in exI)
   apply (simp)
   apply (rule_tac x="[[r]]inv Y" in exI)
   apply (rule_tac x="[[r]]inv Z" in exI)

  apply (simp add: ren_inv_def)
  apply (auto)
done

(* --------------------------------------------------- *
     distribution internal choice over prefix
 * --------------------------------------------------- *)

(*------------------*
 |      csp law     |
 *------------------*)

lemma cspT_Act_prefix_dist:
  "a -> (P |~| Q) =T[M,M] (a -> P) |~| (a -> Q)"
apply (simp add: cspT_semantics)
apply (rule order_antisym)
(* <= *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim disjE conjE exE bexE)
 apply (simp_all)

(* => *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim disjE conjE exE bexE)
 apply (simp_all)
done

lemma cspF_Act_prefix_dist:
  "a -> (P |~| Q) =F[M,M] (a -> P) |~| (a -> Q)"
apply (simp add: cspF_cspT_semantics)
apply (simp add: cspT_Act_prefix_dist)
apply (rule order_antisym)

(* <= *)
 apply (rule)
 apply (simp add: in_failures)
 apply (erule disjE)
  apply (force)

  apply (elim conjE exE disjE bexE)
  apply (force)
  apply (force)

(* => *)
 apply (rule)
 apply (simp add: in_failures)
 apply (elim disjE conjE bexE exE)
  apply (simp)
  apply (simp)
  apply (force)
  apply (force)
done

lemma cspF_Int_choice_Act_prefix_delay:
  "(a -> P) |~| (a -> Q) =F[M,M] a -> (P |~| Q)"
apply (rule cspF_sym)
apply (simp add: cspF_Act_prefix_dist)
done

lemma cspF_Int_choice_Act_prefix_delay_eq:
  "a = b ==> (a -> P) |~| (b -> Q) =F[M,M] a -> (P |~| Q)"
apply (simp add: cspF_Int_choice_Act_prefix_delay)
done


(* --------------------------------------------------- *
     distribution internal choice over prefix choice
 * --------------------------------------------------- *)

(*------------------*
 |      csp law     |
 *------------------*)

lemma cspT_Ext_pre_choice_dist:
  "? x:X -> (Pf x |~| Qf x) =T[M,M] (? x:X -> Pf x) |~| (? x:X -> Qf x)"
apply (simp add: cspT_semantics)
apply (rule order_antisym)
(* <= *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim disjE conjE exE bexE)
 apply (simp_all)

(* => *)
 apply (rule)
 apply (simp add: in_traces)
 apply (elim disjE conjE exE bexE)
 apply (simp_all)
done


lemma cspF_Ext_pre_choice_dist:
  "? x:X -> (Pf x |~| Qf x) =F[M,M] (? x:X -> Pf x) |~| (? x:X -> Qf x)"
apply (simp add: cspF_cspT_semantics)
apply (simp add: cspT_Ext_pre_choice_dist)
apply (rule order_antisym)

(* <= *)
 apply (rule)
 apply (simp add: in_failures)
 apply (erule disjE)
  apply (force)

  apply (elim conjE exE disjE bexE)
  apply (force)
  apply (force)

(* => *)
 apply (rule)
 apply (simp add: in_failures)
 apply (elim disjE conjE bexE exE)
  apply (simp)
  apply (simp)
  apply (force)
  apply (force)
done

lemma cspF_Int_choice_Ext_pre_choice_delay:
  "(? x:X -> Pf x) |~| (? x:X -> Qf x)  =F[M,M] ? x:X -> (Pf x |~| Qf x)"
apply (rule cspF_sym)
apply (simp add: cspF_Ext_pre_choice_dist)
done

lemma cspF_Int_choice_Ext_pre_choice_delay_eq:
  "X = Y ==> (? x:X -> Pf x) |~| (? x:Y -> Qf x)  =F[M,M] ? x:X -> (Pf x |~| Qf x)"
apply (simp add: cspF_Int_choice_Ext_pre_choice_delay)
done

(*  replicated internal choice *)

lemma cspF_Act_prefix_delay_sum:
  "!! c:C .. (a -> Pf c) =F[M,M] 
   IF (sumset C = {}) THEN DIV ELSE (a -> (!! c : C .. (Pf c)))"
apply (rule cspF_rw_right)
apply (rule cspF_IF_split)
apply (case_tac "sumset C = {}")
apply (simp add: cspF_Rep_int_choice_DIV)
apply (simp)
apply (rule cspF_sym)
apply (simp add: cspF_Act_prefix_Dist)
done

lemma cspF_Ext_pre_choice_delay_sum:
  "!! c : C .. (? : X -> (Pf c)) =F[M,M] 
   IF (sumset C = {}) THEN DIV ELSE (? x : X -> (!! c : C .. (Pf c) x))"
apply (rule cspF_rw_right)
apply (rule cspF_IF_split)
apply (case_tac "sumset C = {}")
apply (simp add: cspF_Rep_int_choice_DIV)
apply (simp)
apply (rule cspF_sym)
apply (simp add: cspF_Ext_pre_choice_Dist)
done

lemma cspF_Act_prefix_delay_nat:
  "!nat n:N .. (a -> Pf n) =F[M,M] 
   IF (N = {}) THEN DIV ELSE (a -> (!nat n:N .. (Pf n)))"
apply (rule cspF_rw_right)
apply (rule cspF_IF_split)
apply (case_tac "N = {}")
apply (simp add: cspF_Rep_int_choice_DIV)
apply (simp)
apply (rule cspF_sym)
apply (simp add: cspF_Act_prefix_Dist)
done

lemma cspF_Ext_pre_choice_delay_nat:
  "!nat n:N .. (? :X -> (Pf n)) =F[M,M] 
   IF (N = {}) THEN DIV ELSE (? x:X -> (!nat n:N .. (Pf n) x))"
apply (rule cspF_rw_right)
apply (rule cspF_IF_split)
apply (case_tac "N = {}")
apply (simp add: cspF_Rep_int_choice_DIV)
apply (simp)
apply (rule cspF_sym)
apply (simp add: cspF_Ext_pre_choice_Dist)
done

lemma cspF_Act_prefix_delay_set:
  "!set X:Xs .. (a -> Pf X) =F[M,M] 
   IF (Xs = {}) THEN DIV ELSE (a -> (!set X:Xs .. (Pf X)))"
apply (rule cspF_rw_right)
apply (rule cspF_IF_split)
apply (case_tac "Xs = {}")
apply (simp add: cspF_Rep_int_choice_DIV)
apply (simp)
apply (rule cspF_sym)
apply (simp add: cspF_Act_prefix_Dist)
done

lemma cspF_Ext_pre_choice_delay_set:
  "!set Y:Xs .. (? :X -> (Pf Y)) =F[M,M] 
   IF (Xs = {}) THEN DIV ELSE (? x:X -> (!set Y:Xs .. (Pf Y) x))"
apply (rule cspF_rw_right)
apply (rule cspF_IF_split)
apply (case_tac "Xs = {}")
apply (simp add: cspF_Rep_int_choice_DIV)
apply (simp)
apply (rule cspF_sym)
apply (simp add: cspF_Ext_pre_choice_Dist)
done

lemma cspF_Act_prefix_delay_com:
  "! x:X .. (a -> Pf x) =F[M,M] 
   IF (X = {}) THEN DIV ELSE (a -> (! :X .. Pf))"
apply (rule cspF_rw_right)
apply (rule cspF_IF_split)
apply (case_tac "X = {}")
apply (simp add: cspF_Rep_int_choice_DIV)
apply (simp)
apply (rule cspF_sym)
apply (simp add: cspF_Act_prefix_Dist)
done

lemma cspF_Ext_pre_choice_delay_com:
  "! y:Y .. (? :X -> (Pf y)) =F[M,M] 
   IF (Y = {}) THEN DIV ELSE (? x:X -> (! y:Y .. (Pf y) x))"
apply (rule cspF_rw_right)
apply (rule cspF_IF_split)
apply (case_tac "Y = {}")
apply (simp add: cspF_Rep_int_choice_DIV)
apply (simp)
apply (rule cspF_sym)
apply (simp add: cspF_Ext_pre_choice_Dist)
done

lemma cspF_Act_prefix_delay_f:
  "inj f ==> 
   !<f> x:X .. (a -> Pf x) =F[M,M] 
   IF (X = {}) THEN DIV ELSE (a -> (!<f> :X .. Pf))"
apply (rule cspF_rw_right)
apply (rule cspF_IF_split)
apply (case_tac "X = {}")
apply (simp add: cspF_Rep_int_choice_DIV)
apply (simp)
apply (rule cspF_sym)
apply (simp add: cspF_Act_prefix_Dist)
done

lemma cspF_Ext_pre_choice_delay_f:
  "inj f ==> 
   !<f> y:Y .. (? :X -> (Pf y)) =F[M,M] 
   IF (Y = {}) THEN DIV ELSE (? x:X -> (!<f> y:Y .. (Pf y) x))"
apply (rule cspF_rw_right)
apply (rule cspF_IF_split)
apply (case_tac "Y = {}")
apply (simp add: cspF_Rep_int_choice_DIV)
apply (simp)
apply (rule cspF_sym)
apply (simp add: cspF_Ext_pre_choice_Dist)
done

lemmas cspF_choice_delay =
       cspF_Int_choice_Act_prefix_delay
       cspF_Int_choice_Ext_pre_choice_delay
       cspF_Act_prefix_delay_sum
       cspF_Ext_pre_choice_delay_sum
       cspF_Act_prefix_delay_nat
       cspF_Ext_pre_choice_delay_nat
       cspF_Act_prefix_delay_set
       cspF_Ext_pre_choice_delay_set
       cspF_Act_prefix_delay_com
       cspF_Ext_pre_choice_delay_com
       cspF_Act_prefix_delay_f
       cspF_Ext_pre_choice_delay_f

lemmas cspF_choice_delay_eq =
       cspF_Int_choice_Act_prefix_delay_eq
       cspF_Int_choice_Ext_pre_choice_delay_eq

(*********************************************************
                       P |[X,Y]| Q
 *********************************************************)

(* ---------- *
    |~| left
 * ---------- *)

lemma cspF_Alpha_Parallel_dist_l: 
  "(P1 |~| P2) |[X,Y]| Q =F[M,M]
   (P1 |[X,Y]| Q) |~| (P2 |[X,Y]| Q)"
apply (simp add: Alpha_parallel_def)

apply (rule cspF_rw_left)
apply (rule cspF_decompo)
apply (simp)
apply (rule cspF_dist)
apply (rule cspF_reflex)
apply (rule cspF_rw_left)
apply (rule cspF_dist)
apply (simp)
done

(* ---------- *
    |~| right
 * ---------- *)
lemma cspF_Alpha_Parallel_dist_r: 
  "P |[X,Y]| (Q1 |~| Q2) =F[M,M]
   (P |[X,Y]| Q1) |~| (P |[X,Y]| Q2)"
apply (simp add: Alpha_parallel_def)

apply (rule cspF_rw_left)
apply (rule cspF_decompo)
apply (simp)
apply (rule cspF_reflex)
apply (rule cspF_dist)
apply (rule cspF_rw_left)
apply (rule cspF_dist)
apply (simp)
done

(* ---------- *
    !! left
 * ---------- *)

lemma cspF_Alpha_Parallel_Dist_sum_l_nonempty: 
  "sumset C ~= {} ==>
     (!! :C .. Pf) |[X,Y]| Q =F[M,M]
     !! c:C .. (Pf c |[X,Y]| Q)"
apply (simp add: Alpha_parallel_def)

apply (rule cspF_rw_left)
apply (rule cspF_decompo)
apply (simp)
apply (rule cspF_Parallel_Dist_sum_l_nonempty)
apply (simp)
apply (rule cspF_reflex)
apply (rule cspF_rw_left)
apply (rule cspF_Parallel_Dist_sum_l_nonempty)
apply (simp)
apply (simp)
done

lemma cspF_Alpha_Parallel_Dist_sum_l: 
  "(!! :C .. Pf) |[X,Y]| Q =F[M,M]
   IF (sumset C={}) THEN (DIV |[X,Y]| Q) ELSE (!! c:C .. (Pf c |[X,Y]| Q))"
apply (case_tac "sumset C={}")
apply (simp)
apply (rule cspF_rw_right)
apply (rule cspF_IF)
apply (rule cspF_decompo_Alpha_parallel)
apply (simp)+
apply (simp add: cspF_Rep_int_choice_empty)
apply (simp)

apply (simp)
apply (rule cspF_rw_right)
apply (rule cspF_IF)
apply (rule cspF_Alpha_Parallel_Dist_sum_l_nonempty)
apply (simp)
done

(* ---------- *
    !! right
 * ---------- *)

lemma cspF_Alpha_Parallel_Dist_sum_r_nonempty: 
  "sumset C ~= {} ==>
     P |[X,Y]| (!! :C .. Qf) =F[M,M]
     !! c:C .. (P |[X,Y]| Qf c)"
apply (rule cspF_rw_left)
apply (rule cspF_Alpha_parallel_commut)
apply (rule cspF_rw_left)
apply (rule cspF_Alpha_Parallel_Dist_sum_l_nonempty, simp)
apply (rule cspF_decompo, simp)
apply (rule cspF_Alpha_parallel_commut)
done

lemma cspF_Alpha_Parallel_Dist_sum_r: 
  "P |[X,Y]| (!! :C .. Qf) =F[M,M]
   IF (sumset C={}) THEN (P |[X,Y]| DIV) ELSE (!! c:C .. (P |[X,Y]| Qf c))"
apply (case_tac "sumset C={}")
apply (simp)
apply (rule cspF_rw_right)
apply (rule cspF_IF)
apply (rule cspF_decompo_Alpha_parallel)
apply (simp)+
apply (simp add: cspF_Rep_int_choice_empty)
apply (simp)

apply (rule cspF_rw_right)
apply (rule cspF_IF)
apply (rule cspF_Alpha_Parallel_Dist_sum_r_nonempty)
apply (simp)
done

(* ---------- *
   !nat left
 * ---------- *)

lemma cspF_Alpha_Parallel_Dist_nat_l_nonempty: 
  "N ~= {} ==>
     (!nat :N .. Pf) |[X,Y]| Q =F[M,M]
     !nat n:N .. (Pf n |[X,Y]| Q)"
by (simp add: Rep_int_choice_ss_def cspF_Alpha_Parallel_Dist_sum_l_nonempty)

(*** Dist ***)

lemma cspF_Alpha_Parallel_Dist_nat_l: 
  "(!nat :N .. Pf) |[X,Y]| Q =F[M,M]
   IF (N={}) THEN (DIV |[X,Y]| Q) ELSE (!nat n:N .. (Pf n |[X,Y]| Q))"
apply (simp add: Rep_int_choice_ss_def)
by (rule cspF_rw_left, rule cspF_Alpha_Parallel_Dist_sum_l, simp)

(* ---------- *
   !nat right
 * ---------- *)

lemma cspF_Alpha_Parallel_Dist_nat_r_nonempty: 
  "N ~= {} ==>
     P |[X,Y]| (!nat :N .. Qf) =F[M,M]
     !nat n:N .. (P |[X,Y]| Qf n)"
by (simp add: Rep_int_choice_ss_def cspF_Alpha_Parallel_Dist_sum_r_nonempty)

(*** Dist ***)

lemma cspF_Alpha_Parallel_Dist_nat_r: 
  "P |[X,Y]| (!nat :N .. Qf) =F[M,M]
   IF (N={}) THEN (P |[X,Y]| DIV) ELSE (!nat n:N .. (P |[X,Y]| Qf n))"
apply (simp add: Rep_int_choice_ss_def)
by (rule cspF_rw_left, rule cspF_Alpha_Parallel_Dist_sum_r, simp)

(* ---------- *
   !set left
 * ---------- *)

lemma cspF_Alpha_Parallel_Dist_set_l_nonempty: 
  "Xs ~= {} ==>
     (!set :Xs .. Pf) |[Y,Z]| Q =F[M,M]
     !set X:Xs .. (Pf X |[Y,Z]| Q)"
by (simp add: Rep_int_choice_ss_def cspF_Alpha_Parallel_Dist_sum_l_nonempty)

(*** Dist ***)

lemma cspF_Alpha_Parallel_Dist_set_l: 
  "(!set :Xs .. Pf) |[Y,Z]| Q =F[M,M]
   IF (Xs={}) THEN (DIV |[Y,Z]| Q) ELSE (!set X:Xs .. (Pf X |[Y,Z]| Q))"
apply (simp add: Rep_int_choice_ss_def)
by (rule cspF_rw_left, rule cspF_Alpha_Parallel_Dist_sum_l, simp)

(* ---------- *
   !set right
 * ---------- *)

lemma cspF_Alpha_Parallel_Dist_set_r_nonempty: 
  "Xs ~= {} ==>
     P |[Y,Z]| (!set :Xs .. Qf) =F[M,M]
     !set X:Xs .. (P |[Y,Z]| Qf X)"
by (simp add: Rep_int_choice_ss_def cspF_Alpha_Parallel_Dist_sum_r_nonempty)

(*** Dist ***)

lemma cspF_Alpha_Parallel_Dist_set_r: 
  "P |[Y,Z]| (!set :Xs .. Qf) =F[M,M]
   IF (Xs={}) THEN (P |[Y,Z]| DIV) ELSE (!set X:Xs .. (P |[Y,Z]| Qf X))"
apply (simp add: Rep_int_choice_ss_def)
by (rule cspF_rw_left, rule cspF_Alpha_Parallel_Dist_sum_r, simp)

(* ---------- *
     ! left
 * ---------- *)

lemma cspF_Alpha_Parallel_Dist_com_l_nonempty: 
  "A ~= {}
   ==> (! :A .. Pf) |[X,Y]| Q =F[M,M] ! x:A .. (Pf x |[X,Y]| Q)"
by (simp add: Rep_int_choice_com_def cspF_Alpha_Parallel_Dist_set_l_nonempty)

lemma cspF_Alpha_Parallel_Dist_com_l: 
  "(! :A .. Pf) |[X,Y]| Q =F[M,M]
   IF (A ={}) THEN (DIV |[X,Y]| Q) ELSE (! x:A .. (Pf x |[X,Y]| Q))"
apply (simp add: Rep_int_choice_com_def)
by (rule cspF_rw_left, rule cspF_Alpha_Parallel_Dist_set_l, simp)

(* ---------- *
     ! right
 * ---------- *)

lemma cspF_Alpha_Parallel_Dist_com_r_nonempty: 
  "A ~= {}
   ==> P |[X,Y]| (! :A .. Qf) =F[M,M] ! x:A .. (P |[X,Y]| Qf x)"
by (simp add: Rep_int_choice_com_def cspF_Alpha_Parallel_Dist_set_r_nonempty)

lemma cspF_Alpha_Parallel_Dist_com_r: 
  "P |[X,Y]| (! :A .. Qf) =F[M,M] 
   IF (A ={}) THEN (P |[X,Y]| DIV) ELSE (! x:A .. (P |[X,Y]| Qf x))"
apply (simp add: Rep_int_choice_com_def)
by (rule cspF_rw_left, rule cspF_Alpha_Parallel_Dist_set_r, simp)

(* ---------- *
   !<f> left
 * ---------- *)

lemma cspF_Alpha_Parallel_Dist_f_l_nonempty: 
  "[| inj f ; A ~= {} |]
   ==> (!<f> :A .. Pf) |[X,Y]| Q =F[M,M] !<f> x:A .. (Pf x |[X,Y]| Q)"
by (simp add: Rep_int_choice_f_def cspF_Alpha_Parallel_Dist_com_l_nonempty)

lemma cspF_Alpha_Parallel_Dist_f_l: 
  "(!<f> :A .. Pf) |[X,Y]| Q =F[M,M]
   IF (A ={}) THEN (DIV |[X,Y]| Q) ELSE (!<f> x:A .. (Pf x |[X,Y]| Q))"
apply (simp add: Rep_int_choice_f_def)
by (rule cspF_rw_left, rule cspF_Alpha_Parallel_Dist_com_l, simp)

lemma cspF_Alpha_Parallel_Dist_f_r_nonempty: 
  "[| inj f ; A ~= {} |]
   ==> P |[X,Y]| (!<f> :A .. Qf) =F[M,M] !<f> x:A .. (P |[X,Y]| Qf x)"
by (simp add: Rep_int_choice_f_def cspF_Alpha_Parallel_Dist_com_r_nonempty)

lemma cspF_Alpha_Parallel_Dist_f_r: 
  "P |[X,Y]| (!<f> :A .. Qf) =F[M,M] 
   IF (A ={}) THEN (P |[X,Y]| DIV) ELSE (!<f> x:A .. (P |[X,Y]| Qf x))"
apply (simp add: Rep_int_choice_f_def)
by (rule cspF_rw_left, rule cspF_Alpha_Parallel_Dist_com_r, simp)

lemmas cspF_dist_Alpha_Parallel =
       cspF_Alpha_Parallel_dist_l
       cspF_Alpha_Parallel_dist_r 

lemmas cspF_Dist_Alpha_Parallel =
      cspF_Alpha_Parallel_Dist_sum_l 
      cspF_Alpha_Parallel_Dist_sum_r 
      cspF_Alpha_Parallel_Dist_nat_l 
      cspF_Alpha_Parallel_Dist_nat_r 
      cspF_Alpha_Parallel_Dist_set_l 
      cspF_Alpha_Parallel_Dist_set_r 
      cspF_Alpha_Parallel_Dist_com_l 
      cspF_Alpha_Parallel_Dist_com_r 
      cspF_Alpha_Parallel_Dist_f_l 
      cspF_Alpha_Parallel_Dist_f_r 

lemmas cspF_Dist_Alpha_Parallel_nonempty =
      cspF_Alpha_Parallel_Dist_sum_l_nonempty 
      cspF_Alpha_Parallel_Dist_sum_r_nonempty 
      cspF_Alpha_Parallel_Dist_nat_l_nonempty 
      cspF_Alpha_Parallel_Dist_nat_r_nonempty 
      cspF_Alpha_Parallel_Dist_set_l_nonempty 
      cspF_Alpha_Parallel_Dist_set_r_nonempty 
      cspF_Alpha_Parallel_Dist_com_l_nonempty
      cspF_Alpha_Parallel_Dist_com_r_nonempty 
      cspF_Alpha_Parallel_Dist_f_l_nonempty 
      cspF_Alpha_Parallel_Dist_f_r_nonempty 

end
